PList< T > Class Template Reference

This template class maps the PAbstractList to a specific object type. More...

`#include <lists.h>`

Inheritance diagram for PList< T >:

## Classes

class | const_iterator
class | iterator
class | iterator_base

## Public Member Functions

Construction
| PList ()
| Create a new, empty, list. More...
Overrides from class PObject
virtual PObject * | Clone () const
| Make a complete duplicate of the list. More...
New functions for class
T & | operator[] (PINDEX index) const
| Retrieve a reference to the object in the list. More...
Public Member Functions inherited from PAbstractList
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two lists. More...
PINLINE | PAbstractList ()
| Create a new, empty, list. More...
virtual PBoolean | SetSize (PINDEX newSize)
| This function is meaningless for lists. More...
virtual PINDEX | Append (PObject *obj)
| Append a new object to the collection. More...
virtual PINDEX | Insert (const PObject &before, PObject *obj)
| Insert a new object immediately before the specified object. More...
virtual PINDEX | InsertAt (PINDEX index, PObject *obj)
| Insert a new object at the specified ordinal index. More...
virtual PBoolean | Remove (const PObject *obj)
| Remove the object from the collection. More...
virtual PObject * | RemoveAt (PINDEX index)
| Remove the object at the specified ordinal index from the collection. More...
virtual PBoolean | SetAt (PINDEX index, PObject *val)
| Set the object at the specified ordinal position to the new value. More...
virtual PBoolean | ReplaceAt (PINDEX index, PObject *val)
| Set the object at the specified ordinal position to the new value. More...
virtual PObject * | GetAt (PINDEX index) const
| Get the object at the specified ordinal position. More...
virtual PINDEX | GetObjectsIndex (const PObject *obj) const
| Search the collection for the specific instance of the object. More...
virtual PINDEX | GetValuesIndex (const PObject &obj) const
| Search the collection for the specified value of the object. More...
Public Member Functions inherited from PCollection
| PCollection (PINDEX initialSize=0)
| Create a new collection. More...
virtual void | PrintOn (ostream &strm) const
| Print the collection on the stream. More...
virtual void | RemoveAll ()
| Remove all of the elements in the collection. More...
PINLINE void | AllowDeleteObjects (PBoolean yes=true)
| Allow or disallow the deletion of the objects contained in the collection. More...
void | DisallowDeleteObjects ()
| Disallow the deletion of the objects contained in the collection. More...
Public Member Functions inherited from PContainer
| PContainer (PINDEX initialSize=0)
| Create a new unique container. More...
| PContainer (const PContainer &cont)
| Create a new refernce to container. More...
PContainer & | operator= (const PContainer &cont)
| Assign one container reference to another. More...
virtual | ~PContainer ()
| Destroy the container class. More...
virtual PINDEX | GetSize () const
| Get the current size of the container. More...
PBoolean | SetMinSize (PINDEX minSize)
| Set the minimum size of container. More...
virtual PBoolean | IsEmpty () const
| Determine if the container is empty. More...
PBoolean | IsUnique () const
| Determine if container is unique reference. More...
virtual PBoolean | MakeUnique ()
| Make this instance to be the one and only reference to the container contents. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions

| PList (int dummy, const PList *c)
Protected Member Functions inherited from PAbstractList
PINLINE PObject & | GetReferenceAt (PINDEX index) const
| Get the object at the specified ordinal position. More...
PBoolean | SetCurrent (PINDEX index, PListElement *&lastElement) const
| Move the internal "cursor" to the index position specified. More...
PObject * | RemoveElement (PListElement *element)
Protected Member Functions inherited from PCollection
PINLINE | PCollection (int dummy, const PCollection *coll)
| Constructor used in support of the Clone() function. More...
Protected Member Functions inherited from PContainer
| PContainer (int dummy, const PContainer *cont)
| Constructor used in support of the Clone() function. More...
| PContainer (PContainerReference &reference)
| Construct using static PContainerReference. More...
virtual void | DestroyContents ()=0
| Destroy the container contents. More...
virtual void | AssignContents (const PContainer &c)
| Copy the container contents. More...
void | CopyContents (const PContainer &c)
| Copy the container contents. More...
void | CloneContents (const PContainer *src)
| Create a duplicate of the container contents. More...
void | Destruct ()
| Internal function called from container destructors. More...
virtual void | DestroyReference ()
| Destroy the PContainerReference instance. More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Iterators

typedef T | value_type
iterator | begin ()
iterator | end ()
iterator | rbegin ()
iterator | rend ()
const_iterator | begin () const
const_iterator | end () const
const_iterator | rbegin () const
const_iterator | rend () const
T & | front () const
T & | back () const
void | erase (const iterator &it)
void | erase (const const_iterator &it)

## Additional Inherited Members

Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...
Protected Types inherited from PAbstractList
typedef PListElement | Element
Protected Attributes inherited from PAbstractList
PListInfo * | info
Protected Attributes inherited from PContainer
PContainerReference * | reference

## Detailed Description

### template<class T>
class PList< T >

This template class maps the PAbstractList to a specific object type.

The functions in this class primarily do all the appropriate casting of types.

Note that if templates are not used the `PDECLARE_LIST` macro will simulate the template instantiation.

## Member Typedef Documentation

template<class T>

typedef T PList< T >::value_type

## Constructor & Destructor Documentation

template<class T>

PList< T >::PList | ( |  | ) |

inline

Create a new, empty, list.

Note that by default, objects placed into the list will be deleted when removed or when all references to the list are destroyed.

Referenced by PList< PMultiPartInfo >::Clone().

template<class T>

PList< T >::PList | ( | int | dummy,
|  | const PList< T > * | c
| ) |  |

inline protected

## Member Function Documentation

template<class T>

T& PList< T >::back | ( |  | ) | const

inline

template<class T>

iterator PList< T >::begin | ( |  | ) |

inline

template<class T>

const_iterator PList< T >::begin | ( |  | ) | const

inline

template<class T>

virtual PObject* PList< T >::Clone | ( |  | ) | const

inline virtual

Make a complete duplicate of the list.

Note that all objects in the array are also cloned, so this will make a complete copy of the list.

Reimplemented from PObject.

template<class T>

iterator PList< T >::end | ( |  | ) |

inline

template<class T>

const_iterator PList< T >::end | ( |  | ) | const

inline

template<class T>

void PList< T >::erase | ( | const iterator & | it | ) |

inline

template<class T>

void PList< T >::erase | ( | const const_iterator & | it | ) |

inline

template<class T>

T& PList< T >::front | ( |  | ) | const

inline

template<class T>

T& PList< T >::operator[] | ( | PINDEX | index | ) | const

inline

Retrieve a reference to the object in the list.

If there was not an object at that ordinal position or the index was beyond the size of the array then the function asserts.

The object accessed in this way is remembered by the class and further access will be fast. Access to elements one either side of that saved element, and the head and tail of the list, will always be fast.

Returns
  reference to the object at `index` position.

Parameters

  index | Index for entry

template<class T>

iterator PList< T >::rbegin | ( |  | ) |

inline

template<class T>

const_iterator PList< T >::rbegin | ( |  | ) | const

inline

template<class T>

iterator PList< T >::rend | ( |  | ) |

inline

template<class T>

const_iterator PList< T >::rend | ( |  | ) | const

inline

The documentation for this class was generated from the following file:

- lists.h